import BattleshipAdv.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*; 
import java.util.*;
import java.io.*;

public class BsProg {

    public static void main(String args[]) {
        try {
            // create and initialize the ORB
            ORB orb = ORB.init(args, null);

            // fill the battlefield
            boolean[][] bf = new boolean[8][8];
            Random rnd = new Random();
            for (int j = 0; j < 16; j++) {
              int k = Math.abs(rnd.nextInt()) % 64;
              int row = k / 8;
              int col = k % 8;
              bf[row][col] = true;
            }
 
            // create servant and register it with the ORB
            BsServant bsref1 = new BsServant(bf);
            orb.connect(bsref1);
 
            // get the root naming context
            org.omg.CORBA.Object objRef = 
                orb.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);
	    if (ncRef == null) System.out.println
                    (" Naming Context Null Pointer"); 
 
            // bind the Object Reference in Naming
            NameComponent nc1 = new NameComponent(args[0], "");
            NameComponent path1[] = {nc1};
            ncRef.rebind(path1, bsref1);
	    System.out.println(args[0] +" Servant object started\n");

            // resolve the Object Reference in Naming
            NameComponent nc2  = new NameComponent(args[1], "");
            NameComponent path2[] = {nc2};
            Bs bsref2 = null;
            do {
              try {
                 bsref2 = BsHelper.narrow(ncRef.resolve(path2));
              }
              catch (Exception e){}
            }
            while (bsref2 == null);
	    System.out.println(args[1] + " has been found\n");
 
            // run local client
            BufferedReader stdin =
                  new BufferedReader(new InputStreamReader(System.in));
            String line;
            int i, j;
            while (true) {
               try {
                  System.out.print("Row =");
                  line = stdin.readLine();
                  i = Integer.parseInt(line);
                  System.out.print("Column =");
                  line = stdin.readLine();
                  j = Integer.parseInt(line);
                  if ((i > 7) || (j > 7)) break;
                  System.out.println(bsref2.shot(i, j));
               }
               catch (Exception e) {}
            }
            ncRef.unbind(path1);
            orb.disconnect(bsref1);    
        } 
        catch (Exception e) {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }
    }
}
 

